Index: uspace/drv/bus/usb/usbhub/usbhub.c
===================================================================
--- uspace/drv/bus/usb/usbhub/usbhub.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbhub/usbhub.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -81,6 +81,6 @@
 };
 
-static errno_t usb_set_first_configuration(usb_device_t *usb_device);
-static errno_t usb_hub_process_hub_specific_info(usb_hub_dev_t *hub_dev);
+static int usb_set_first_configuration(usb_device_t *usb_device);
+static int usb_hub_process_hub_specific_info(usb_hub_dev_t *hub_dev);
 static void usb_hub_over_current(const usb_hub_dev_t *hub_dev,
     usb_hub_status_t status);
@@ -97,5 +97,5 @@
  * @return error code
  */
-errno_t usb_hub_device_add(usb_device_t *usb_dev)
+int usb_hub_device_add(usb_device_t *usb_dev)
 {
 	assert(usb_dev);
@@ -114,5 +114,5 @@
 
 	/* Set hub's first configuration. (There should be only one) */
-	errno_t opResult = usb_set_first_configuration(usb_dev);
+	int opResult = usb_set_first_configuration(usb_dev);
 	if (opResult != EOK) {
 		usb_log_error("Could not set hub configuration: %s\n",
@@ -174,5 +174,5 @@
  * @return error code
  */
-errno_t usb_hub_device_remove(usb_device_t *usb_dev)
+int usb_hub_device_remove(usb_device_t *usb_dev)
 {
 	return ENOTSUP;
@@ -184,5 +184,5 @@
  * @return error code
  */
-errno_t usb_hub_device_gone(usb_device_t *usb_dev)
+int usb_hub_device_gone(usb_device_t *usb_dev)
 {
 	assert(usb_dev);
@@ -202,5 +202,5 @@
 
 	for (size_t port = 0; port < hub->port_count; ++port) {
-		const errno_t ret = usb_hub_port_fini(&hub->ports[port], hub);
+		const int ret = usb_hub_port_fini(&hub->ports[port], hub);
 		if (ret != EOK)
 			return ret;
@@ -208,5 +208,5 @@
 	free(hub->ports);
 
-	const errno_t ret = ddf_fun_unbind(hub->hub_fun);
+	const int ret = ddf_fun_unbind(hub->hub_fun);
 	if (ret != EOK) {
 		usb_log_error("(%p) Failed to unbind '%s' function: %s.",
@@ -266,5 +266,5 @@
  * @return error code
  */
-static errno_t usb_hub_process_hub_specific_info(usb_hub_dev_t *hub_dev)
+static int usb_hub_process_hub_specific_info(usb_hub_dev_t *hub_dev)
 {
 	assert(hub_dev);
@@ -277,5 +277,5 @@
 	usb_hub_descriptor_header_t descriptor;
 	size_t received_size;
-	errno_t opResult = usb_request_get_descriptor(control_pipe,
+	int opResult = usb_request_get_descriptor(control_pipe,
 	    USB_REQUEST_TYPE_CLASS, USB_REQUEST_RECIPIENT_DEVICE,
 	    USB_DESCTYPE_HUB, 0, 0, &descriptor,
@@ -317,5 +317,5 @@
 	for (unsigned int port = 0; port < hub_dev->port_count; ++port) {
 		usb_log_debug("(%p): Powering port %u.", hub_dev, port);
-		const errno_t ret = usb_hub_port_set_feature(
+		const int ret = usb_hub_port_set_feature(
 		    &hub_dev->ports[port], USB_HUB_FEATURE_PORT_POWER);
 
@@ -343,5 +343,5 @@
  * @return error code
  */
-static errno_t usb_set_first_configuration(usb_device_t *usb_device)
+static int usb_set_first_configuration(usb_device_t *usb_device)
 {
 	assert(usb_device);
@@ -369,5 +369,5 @@
 	/* Set configuration. Use the configuration that was in
 	 * usb_device->descriptors.configuration i.e. The first one. */
-	const errno_t opResult = usb_request_set_configuration(
+	const int opResult = usb_request_set_configuration(
 	    usb_device_get_default_pipe(usb_device),
 	    config_descriptor->configuration_number);
@@ -406,5 +406,5 @@
 	/* Over-current condition is gone, it is safe to turn the ports on. */
 	for (size_t port = 0; port < hub_dev->port_count; ++port) {
-		const errno_t ret = usb_hub_port_set_feature(
+		const int ret = usb_hub_port_set_feature(
 		    &hub_dev->ports[port], USB_HUB_FEATURE_PORT_POWER);
 		if (ret != EOK) {
@@ -438,5 +438,5 @@
 	/* NOTE: We can't use standard USB GET_STATUS request, because
 	 * hubs reply is 4byte instead of 2 */
-	const errno_t opResult = usb_pipe_control_read(control_pipe,
+	const int opResult = usb_pipe_control_read(control_pipe,
 	    &get_hub_status_request, sizeof(get_hub_status_request),
 	    &status, sizeof(usb_hub_status_t), &rcvd_size);
@@ -456,5 +456,5 @@
 		usb_hub_over_current(hub_dev, status);
 		/* Ack change in hub OC flag */
-		const errno_t ret = usb_request_clear_feature(
+		const int ret = usb_request_clear_feature(
 		    control_pipe, USB_REQUEST_TYPE_CLASS,
 		    USB_REQUEST_RECIPIENT_DEVICE,
@@ -480,5 +480,5 @@
 		 * Just ACK the change.
 		 */
-		const errno_t ret = usb_request_clear_feature(
+		const int ret = usb_request_clear_feature(
 		    control_pipe, USB_REQUEST_TYPE_CLASS,
 		    USB_REQUEST_RECIPIENT_DEVICE,
Index: uspace/drv/bus/usb/usbhub/usbhub.h
===================================================================
--- uspace/drv/bus/usb/usbhub/usbhub.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbhub/usbhub.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -83,7 +83,7 @@
 extern const usb_endpoint_description_t hub_status_change_endpoint_description;
 
-extern errno_t usb_hub_device_add(usb_device_t *);
-extern errno_t usb_hub_device_remove(usb_device_t *);
-extern errno_t usb_hub_device_gone(usb_device_t *);
+extern int usb_hub_device_add(usb_device_t *);
+extern int usb_hub_device_remove(usb_device_t *);
+extern int usb_hub_device_gone(usb_device_t *);
 
 extern bool hub_port_changes_callback(usb_device_t *, uint8_t *, size_t,
Index: uspace/drv/bus/usb/usbmid/explore.c
===================================================================
--- uspace/drv/bus/usb/usbmid/explore.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbmid/explore.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,5 +66,5 @@
  * @param list List where to add the interfaces.
  */
-static errno_t create_interfaces(const uint8_t *config_descriptor,
+static int create_interfaces(const uint8_t *config_descriptor,
     size_t config_descriptor_size, list_t *list, usb_device_t *usb_dev)
 {
@@ -111,5 +111,5 @@
 
 		usbmid_interface_t *iface = NULL;
-		const errno_t rc = usbmid_spawn_interface_child(usb_dev, &iface,
+		const int rc = usbmid_spawn_interface_child(usb_dev, &iface,
 			&usb_device_descriptors(usb_dev)->device, interface);
 		if (rc != EOK) {
@@ -134,5 +134,5 @@
  * @return Whether to accept this device.
  */
-errno_t usbmid_explore_device(usb_device_t *dev)
+int usbmid_explore_device(usb_device_t *dev)
 {
 	assert(dev);
@@ -157,5 +157,5 @@
 
 	/* Select the first configuration */
-	errno_t rc = usb_request_set_configuration(usb_device_get_default_pipe(dev),
+	int rc = usb_request_set_configuration(usb_device_get_default_pipe(dev),
 	    config_descriptor->configuration_number);
 	if (rc != EOK) {
Index: uspace/drv/bus/usb/usbmid/main.c
===================================================================
--- uspace/drv/bus/usb/usbmid/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbmid/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
  * @return Error code.
  */
-static errno_t usbmid_device_add(usb_device_t *dev)
+static int usbmid_device_add(usb_device_t *dev)
 {
 	usb_log_info("Taking care of new MID `%s'.\n", usb_device_get_name(dev));
@@ -61,5 +61,5 @@
  * @return Error code.
  */
-static errno_t usbmid_device_remove(usb_device_t *dev)
+static int usbmid_device_remove(usb_device_t *dev)
 {
 	assert(dev);
@@ -68,5 +68,5 @@
 
 	/* Remove ctl function */
-	errno_t ret = ddf_fun_unbind(usb_mid->ctl_fun);
+	int ret = ddf_fun_unbind(usb_mid->ctl_fun);
 	if (ret != EOK) {
 		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
@@ -87,5 +87,5 @@
 
 		/* Tell the child to go off-line. */
-		errno_t pret = ddf_fun_offline(iface->fun);
+		int pret = ddf_fun_offline(iface->fun);
 		if (pret != EOK) {
 			usb_log_warning("Failed to turn off child `%s': %s\n",
@@ -110,5 +110,5 @@
  * @return Error code.
  */
-static errno_t usbmid_device_gone(usb_device_t *dev)
+static int usbmid_device_gone(usb_device_t *dev)
 {
 	assert(dev);
@@ -119,5 +119,5 @@
 
 	/* Remove ctl function */
-	errno_t ret = ddf_fun_unbind(usb_mid->ctl_fun);
+	int ret = ddf_fun_unbind(usb_mid->ctl_fun);
 	if (ret != EOK) {
 		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
@@ -137,5 +137,5 @@
 		    ddf_fun_get_name(iface->fun));
 
-		const errno_t pret = usbmid_interface_destroy(iface);
+		const int pret = usbmid_interface_destroy(iface);
 		if (pret != EOK) {
 			usb_log_error("Failed to remove child `%s': %s\n",
Index: uspace/drv/bus/usb/usbmid/usbmid.c
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbmid/usbmid.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
  * @return Error code.
  */
-static errno_t usb_iface_device_handle(ddf_fun_t *fun, devman_handle_t *handle)
+static int usb_iface_device_handle(ddf_fun_t *fun, devman_handle_t *handle)
 {
 	assert(fun);
@@ -61,5 +61,5 @@
 
 /** Callback for DDF USB get interface. */
-static errno_t usb_iface_iface_no(ddf_fun_t *fun, int *iface_no)
+static int usb_iface_iface_no(ddf_fun_t *fun, int *iface_no)
 {
 	usbmid_interface_t *iface = ddf_fun_data_get(fun);
@@ -83,9 +83,9 @@
 };
 
-errno_t usbmid_interface_destroy(usbmid_interface_t *mid_iface)
+int usbmid_interface_destroy(usbmid_interface_t *mid_iface)
 {
 	assert(mid_iface);
 	assert_link_not_used(&mid_iface->link);
-	const errno_t ret = ddf_fun_unbind(mid_iface->fun);
+	const int ret = ddf_fun_unbind(mid_iface->fun);
 	if (ret != EOK) {
 		return ret;
@@ -103,5 +103,5 @@
  * @return Error code.
  */
-errno_t usbmid_spawn_interface_child(usb_device_t *parent,
+int usbmid_spawn_interface_child(usb_device_t *parent,
     usbmid_interface_t **iface_ret,
     const usb_standard_device_descriptor_t *device_descriptor,
@@ -110,5 +110,5 @@
 	ddf_fun_t *child = NULL;
 	char *child_name = NULL;
-	errno_t rc;
+	int rc;
 
 	/*
@@ -117,8 +117,8 @@
 	 * class name something humanly understandable.
 	 */
-	int ret = asprintf(&child_name, "%s%hhu",
+	rc = asprintf(&child_name, "%s%hhu",
 	    usb_str_class(interface_descriptor->interface_class),
 	    interface_descriptor->interface_number);
-	if (ret < 0) {
+	if (rc < 0) {
 		return ENOMEM;
 	}
Index: uspace/drv/bus/usb/usbmid/usbmid.h
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/usbmid/usbmid.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,10 +62,10 @@
 } usb_mid_t;
 
-extern errno_t usbmid_explore_device(usb_device_t *);
-extern errno_t usbmid_spawn_interface_child(usb_device_t *, usbmid_interface_t **,
+extern int usbmid_explore_device(usb_device_t *);
+extern int usbmid_spawn_interface_child(usb_device_t *, usbmid_interface_t **,
     const usb_standard_device_descriptor_t *,
     const usb_standard_interface_descriptor_t *);
 extern void usbmid_dump_descriptors(uint8_t *, size_t);
-extern errno_t usbmid_interface_destroy(usbmid_interface_t *mid_iface);
+extern int usbmid_interface_destroy(usbmid_interface_t *mid_iface);
 
 static inline usbmid_interface_t * usbmid_interface_from_link(link_t *item)
Index: uspace/drv/bus/usb/vhc/conndev.c
===================================================================
--- uspace/drv/bus/usb/vhc/conndev.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/conndev.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -75,6 +75,6 @@
 	}
 	
-	errno_t data_request_rc;
-	errno_t opening_request_rc;
+	sysarg_t data_request_rc;
+	sysarg_t opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -102,5 +102,5 @@
 	
 	if (callback) {
-		errno_t rc = vhc_virtdev_plug(vhc, callback, &plugged_device_handle);
+		int rc = vhc_virtdev_plug(vhc, callback, &plugged_device_handle);
 		if (rc != EOK) {
 			async_answer_0(icallid, rc);
Index: uspace/drv/bus/usb/vhc/devconn.c
===================================================================
--- uspace/drv/bus/usb/vhc/devconn.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/devconn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
 }
 
-static errno_t vhc_virtdev_plug_generic(vhc_data_t *vhc,
+static int vhc_virtdev_plug_generic(vhc_data_t *vhc,
     async_sess_t *sess, usbvirt_device_t *virtdev,
     uintptr_t *handle, bool connect, usb_address_t address)
@@ -85,15 +85,15 @@
 }
 
-errno_t vhc_virtdev_plug(vhc_data_t *vhc, async_sess_t *sess, uintptr_t *handle)
+int vhc_virtdev_plug(vhc_data_t *vhc, async_sess_t *sess, uintptr_t *handle)
 {
 	return vhc_virtdev_plug_generic(vhc, sess, NULL, handle, true, 0);
 }
 
-errno_t vhc_virtdev_plug_local(vhc_data_t *vhc, usbvirt_device_t *dev, uintptr_t *handle)
+int vhc_virtdev_plug_local(vhc_data_t *vhc, usbvirt_device_t *dev, uintptr_t *handle)
 {
 	return vhc_virtdev_plug_generic(vhc, NULL, dev, handle, true, 0);
 }
 
-errno_t vhc_virtdev_plug_hub(vhc_data_t *vhc, usbvirt_device_t *dev,
+int vhc_virtdev_plug_hub(vhc_data_t *vhc, usbvirt_device_t *dev,
     uintptr_t *handle, usb_address_t address)
 {
Index: uspace/drv/bus/usb/vhc/hub/hub.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/hub.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/hub/hub.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,5 +63,5 @@
 static void set_port_status_change(hub_port_t *, hub_status_change_t);
 static void clear_port_status_change(hub_port_t *, uint16_t);
-static errno_t set_port_state_delayed_fibril(void *);
+static int set_port_state_delayed_fibril(void *);
 static void set_port_state_delayed(hub_t *, size_t, suseconds_t,
     hub_port_state_t, hub_port_state_t);
@@ -163,5 +163,5 @@
  * @return Error code.
  */
-errno_t hub_disconnect_device(hub_t *hub, void *device)
+int hub_disconnect_device(hub_t *hub, void *device)
 {
 	size_t index = hub_find_device(hub, device);
@@ -461,5 +461,5 @@
  * @return Always EOK.
  */
-static errno_t set_port_state_delayed_fibril(void *arg)
+static int set_port_state_delayed_fibril(void *arg)
 {
 	struct delay_port_state_change *change
Index: uspace/drv/bus/usb/vhc/hub/hub.h
===================================================================
--- uspace/drv/bus/usb/vhc/hub/hub.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/hub/hub.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -102,5 +102,5 @@
 void hub_init(hub_t *);
 size_t hub_connect_device(hub_t *, void *);
-errno_t hub_disconnect_device(hub_t *, void *);
+int hub_disconnect_device(hub_t *, void *);
 size_t hub_find_device(hub_t *, void *);
 void hub_acquire(hub_t *);
Index: uspace/drv/bus/usb/vhc/hub/virthub.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/virthub.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/hub/virthub.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include <ddf/driver.h>
 
@@ -148,5 +147,5 @@
  * @return Error code.
  */
-errno_t virthub_init(usbvirt_device_t *dev, const char* name)
+int virthub_init(usbvirt_device_t *dev, const char* name)
 {
 	if (dev == NULL) {
@@ -156,16 +155,14 @@
 	dev->descriptors = &descriptors;
 	dev->address = 0;
-
-	char *n = str_dup(name);
-	if (!n)
+	dev->name = str_dup(name);
+	if (!dev->name)
 		return ENOMEM;
 
 	hub_t *hub = malloc(sizeof(hub_t));
 	if (hub == NULL) {
-		free(n);
+		free(dev->name);
 		return ENOMEM;
 	}
 
-	dev->name = n;
 	hub_init(hub);
 	dev->device_data = hub;
@@ -200,5 +197,5 @@
  * @return Error code.
  */
-errno_t virthub_disconnect_device(usbvirt_device_t *dev, vhc_virtdev_t *conn)
+int virthub_disconnect_device(usbvirt_device_t *dev, vhc_virtdev_t *conn)
 {
 	assert(dev != NULL);
Index: uspace/drv/bus/usb/vhc/hub/virthub.h
===================================================================
--- uspace/drv/bus/usb/vhc/hub/virthub.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/hub/virthub.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -80,7 +80,7 @@
 extern hub_descriptor_t hub_descriptor;
 
-errno_t virthub_init(usbvirt_device_t *, const char *name);
+int virthub_init(usbvirt_device_t *, const char *name);
 int virthub_connect_device(usbvirt_device_t *, vhc_virtdev_t *);
-errno_t virthub_disconnect_device(usbvirt_device_t *, vhc_virtdev_t *);
+int virthub_disconnect_device(usbvirt_device_t *, vhc_virtdev_t *);
 bool virthub_is_device_enabled(usbvirt_device_t *, vhc_virtdev_t *);
 void virthub_get_status(usbvirt_device_t *, char *, size_t);
Index: uspace/drv/bus/usb/vhc/hub/virthubops.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,5 +63,5 @@
 
 /** Callback for data request. */
-static errno_t req_on_status_change_pipe(usbvirt_device_t *dev,
+static int req_on_status_change_pipe(usbvirt_device_t *dev,
     usb_endpoint_t endpoint, usb_transfer_type_t tr_type,
     void *buffer, size_t buffer_size, size_t *actual_size)
@@ -109,5 +109,5 @@
  * @return Error code.
  */
-static errno_t req_clear_hub_feature(usbvirt_device_t *dev,
+static int req_clear_hub_feature(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -123,9 +123,9 @@
  * @return Error code.
  */
-static errno_t req_clear_port_feature(usbvirt_device_t *dev,
-    const usb_device_request_setup_packet_t *request, uint8_t *data,
-    size_t *act_size)
-{
-	errno_t rc;
+static int req_clear_port_feature(usbvirt_device_t *dev,
+    const usb_device_request_setup_packet_t *request, uint8_t *data,
+    size_t *act_size)
+{
+	int rc;
 	size_t port = request->index - 1;
 	usb_hub_class_feature_t feature = request->value;
@@ -203,5 +203,5 @@
  * @return Error code.
  */
-static errno_t req_get_bus_state(usbvirt_device_t *dev,
+static int req_get_bus_state(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -217,5 +217,5 @@
  * @return Error code.
  */
-static errno_t req_get_descriptor(usbvirt_device_t *dev,
+static int req_get_descriptor(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -238,5 +238,5 @@
  * @return Error code.
  */
-static errno_t req_get_hub_status(usbvirt_device_t *dev,
+static int req_get_hub_status(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -257,5 +257,5 @@
  * @return Error code.
  */
-static errno_t req_get_port_status(usbvirt_device_t *dev,
+static int req_get_port_status(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -282,5 +282,5 @@
  * @return Error code.
  */
-static errno_t req_set_hub_feature(usbvirt_device_t *dev,
+static int req_set_hub_feature(usbvirt_device_t *dev,
     const usb_device_request_setup_packet_t *request, uint8_t *data,
     size_t *act_size)
@@ -296,9 +296,9 @@
  * @return Error code.
  */
-static errno_t req_set_port_feature(usbvirt_device_t *dev,
-    const usb_device_request_setup_packet_t *request, uint8_t *data,
-    size_t *act_size)
-{
-	errno_t rc = ENOTSUP;
+static int req_set_port_feature(usbvirt_device_t *dev,
+    const usb_device_request_setup_packet_t *request, uint8_t *data,
+    size_t *act_size)
+{
+	int rc = ENOTSUP;
 	size_t port = request->index - 1;
 	usb_hub_class_feature_t feature = request->value;
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
 };
 
-static errno_t vhc_control_node(ddf_dev_t *dev, ddf_fun_t **fun)
+static int vhc_control_node(ddf_dev_t *dev, ddf_fun_t **fun)
 {
 	assert(dev);
@@ -63,5 +63,5 @@
 	}
 	ddf_fun_set_ops(*fun, &vhc_ops);
-	const errno_t ret = ddf_fun_bind(*fun);
+	const int ret = ddf_fun_bind(*fun);
 	if (ret != EOK) {
 		ddf_fun_destroy(*fun);
@@ -77,9 +77,9 @@
 };
 
-static errno_t vhc_dev_add(ddf_dev_t *dev)
+static int vhc_dev_add(ddf_dev_t *dev)
 {
 	/* Initialize virtual structure */
 	ddf_fun_t *ctl_fun = NULL;
-	errno_t ret = vhc_control_node(dev, &ctl_fun);
+	int ret = vhc_control_node(dev, &ctl_fun);
 	if (ret != EOK) {
 		usb_log_error("Failed to setup control node.\n");
Index: uspace/drv/bus/usb/vhc/transfer.c
===================================================================
--- uspace/drv/bus/usb/vhc/transfer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/transfer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,8 +58,8 @@
 }
 
-static errno_t process_transfer_local(usb_transfer_batch_t *batch,
+static int process_transfer_local(usb_transfer_batch_t *batch,
     usbvirt_device_t *dev, size_t *actual_data_size)
 {
-	errno_t rc;
+	int rc;
 	
 	const usb_direction_t dir = usb_transfer_batch_direction(batch);
@@ -94,8 +94,8 @@
 }
 
-static errno_t process_transfer_remote(usb_transfer_batch_t *batch,
+static int process_transfer_remote(usb_transfer_batch_t *batch,
     async_sess_t *sess, size_t *actual_data_size)
 {
-	errno_t rc;
+	int rc;
 
 	const usb_direction_t dir = usb_transfer_batch_direction(batch);
@@ -143,5 +143,5 @@
 
 static void execute_transfer_callback_and_free(vhc_transfer_t *transfer,
-    size_t data_transfer_size, errno_t outcome)
+    size_t data_transfer_size, int outcome)
 {
 	assert(outcome != ENAK);
@@ -154,5 +154,5 @@
 }
 
-errno_t vhc_init(vhc_data_t *instance)
+int vhc_init(vhc_data_t *instance)
 {
 	assert(instance);
@@ -163,5 +163,5 @@
 }
 
-errno_t vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
+int vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
 {
 	assert(hcd);
@@ -199,5 +199,5 @@
 }
 
-errno_t vhc_transfer_queue_processor(void *arg)
+int vhc_transfer_queue_processor(void *arg)
 {
 	vhc_virtdev_t *dev = arg;
@@ -214,5 +214,5 @@
 		fibril_mutex_unlock(&dev->guard);
 
-		errno_t rc = EOK;
+		int rc = EOK;
 		size_t data_transfer_size = 0;
 		if (dev->dev_sess) {
Index: uspace/drv/bus/usb/vhc/vhcd.h
===================================================================
--- uspace/drv/bus/usb/vhc/vhcd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/bus/usb/vhc/vhcd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,12 +71,12 @@
     ipc_call_t *icall);
 
-errno_t vhc_virtdev_plug(vhc_data_t *, async_sess_t *, uintptr_t *);
-errno_t vhc_virtdev_plug_local(vhc_data_t *, usbvirt_device_t *, uintptr_t *);
-errno_t vhc_virtdev_plug_hub(vhc_data_t *, usbvirt_device_t *, uintptr_t *, usb_address_t address);
+int vhc_virtdev_plug(vhc_data_t *, async_sess_t *, uintptr_t *);
+int vhc_virtdev_plug_local(vhc_data_t *, usbvirt_device_t *, uintptr_t *);
+int vhc_virtdev_plug_hub(vhc_data_t *, usbvirt_device_t *, uintptr_t *, usb_address_t address);
 void vhc_virtdev_unplug(vhc_data_t *, uintptr_t);
 
-errno_t vhc_init(vhc_data_t *instance);
-errno_t vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
-errno_t vhc_transfer_queue_processor(void *arg);
+int vhc_init(vhc_data_t *instance);
+int vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
+int vhc_transfer_queue_processor(void *arg);
 
 #endif
Index: uspace/drv/char/i8042/i8042.c
===================================================================
--- uspace/drv/char/i8042/i8042.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/i8042/i8042.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -68,6 +68,6 @@
 
 static void i8042_char_conn(ipc_callid_t, ipc_call_t *, void *);
-static errno_t i8042_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t i8042_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int i8042_read(chardev_srv_t *, void *, size_t, size_t *);
+static int i8042_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static chardev_ops_t i8042_chardev_ops = {
@@ -129,5 +129,5 @@
 {
 	i8042_t *controller = ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 	
 	const uint8_t status = IPC_GET_ARG1(*call);
@@ -158,5 +158,5 @@
  *
  */
-errno_t i8042_init(i8042_t *dev, addr_range_t *regs, int irq_kbd,
+int i8042_init(i8042_t *dev, addr_range_t *regs, int irq_kbd,
     int irq_mouse, ddf_dev_t *ddf_dev)
 {
@@ -170,5 +170,5 @@
 	i8042_regs_t *ar;
 	
-	errno_t rc;
+	int rc;
 	bool kbd_bound = false;
 	bool aux_bound = false;
@@ -281,8 +281,8 @@
 	};
 	
-	int irq_kbd_cap;
-	rc = register_interrupt_handler(ddf_dev, irq_kbd,
-	    i8042_irq_handler, &irq_code, &irq_kbd_cap);
-	if (rc != EOK) {
+	const int irq_kbd_cap = register_interrupt_handler(ddf_dev, irq_kbd,
+	    i8042_irq_handler, &irq_code);
+	if (irq_kbd_cap < 0) {
+		rc = irq_kbd_cap;
 		ddf_msg(LVL_ERROR, "Failed set handler for kbd: %s.",
 		    ddf_dev_get_name(ddf_dev));
@@ -290,8 +290,8 @@
 	}
 	
-	int irq_mouse_cap;
-	rc = register_interrupt_handler(ddf_dev, irq_mouse,
-	    i8042_irq_handler, &irq_code, &irq_mouse_cap);
-	if (rc != EOK) {
+	const int irq_mouse_cap = register_interrupt_handler(ddf_dev, irq_mouse,
+	    i8042_irq_handler, &irq_code);
+	if (irq_mouse_cap < 0) {
+		rc = irq_mouse_cap;
 		ddf_msg(LVL_ERROR, "Failed set handler for mouse: %s.",
 		    ddf_dev_get_name(ddf_dev));
@@ -350,5 +350,5 @@
  *
  */
-static errno_t i8042_write(chardev_srv_t *srv, const void *data, size_t size,
+static int i8042_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwr)
 {
@@ -385,5 +385,5 @@
  *
  */
-static errno_t i8042_read(chardev_srv_t *srv, void *dest, size_t size,
+static int i8042_read(chardev_srv_t *srv, void *dest, size_t size,
     size_t *nread)
 {
@@ -391,5 +391,5 @@
 	size_t p;
 	uint8_t *destp = (uint8_t *)dest;
-	errno_t rc;
+	int rc;
 	
 	fibril_mutex_lock(&port->buf_lock);
Index: uspace/drv/char/i8042/i8042.h
===================================================================
--- uspace/drv/char/i8042/i8042.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/i8042/i8042.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -88,5 +88,5 @@
 } i8042_t;
 
-extern errno_t i8042_init(i8042_t *, addr_range_t *, int, int, ddf_dev_t *);
+extern int i8042_init(i8042_t *, addr_range_t *, int, int, ddf_dev_t *);
 
 #endif
Index: uspace/drv/char/i8042/main.c
===================================================================
--- uspace/drv/char/i8042/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/i8042/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -55,5 +55,5 @@
  *
  */
-static errno_t get_my_registers(ddf_dev_t *dev, addr_range_t *p_io_reg,
+static int get_my_registers(ddf_dev_t *dev, addr_range_t *p_io_reg,
     int *kbd_irq, int *mouse_irq)
 {
@@ -66,5 +66,5 @@
 	hw_res_list_parsed_t hw_resources;
 	hw_res_list_parsed_init(&hw_resources);
-	const errno_t ret = hw_res_get_list_parsed(parent_sess, &hw_resources, 0);
+	const int ret = hw_res_get_list_parsed(parent_sess, &hw_resources, 0);
 	if (ret != EOK)
 		return ret;
@@ -96,10 +96,10 @@
  *
  */
-static errno_t i8042_dev_add(ddf_dev_t *device)
+static int i8042_dev_add(ddf_dev_t *device)
 {
 	addr_range_t io_regs;
 	int kbd = 0;
 	int mouse = 0;
-	errno_t rc;
+	int rc;
 	
 	if (!device)
Index: uspace/drv/char/msim-con/main.c
===================================================================
--- uspace/drv/char/msim-con/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/char/msim-con/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 #define NAME  "msim-con"
 
-static errno_t msim_con_dev_add(ddf_dev_t *dev);
-static errno_t msim_con_dev_remove(ddf_dev_t *dev);
-static errno_t msim_con_dev_gone(ddf_dev_t *dev);
-static errno_t msim_con_fun_online(ddf_fun_t *fun);
-static errno_t msim_con_fun_offline(ddf_fun_t *fun);
+static int msim_con_dev_add(ddf_dev_t *dev);
+static int msim_con_dev_remove(ddf_dev_t *dev);
+static int msim_con_dev_gone(ddf_dev_t *dev);
+static int msim_con_fun_online(ddf_fun_t *fun);
+static int msim_con_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t driver_ops = {
@@ -62,9 +62,9 @@
 };
 
-static errno_t msim_con_get_res(ddf_dev_t *dev, msim_con_res_t *res)
+static int msim_con_get_res(ddf_dev_t *dev, msim_con_res_t *res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -97,9 +97,9 @@
 }
 
-static errno_t msim_con_dev_add(ddf_dev_t *dev)
+static int msim_con_dev_add(ddf_dev_t *dev)
 {
 	msim_con_t *msim_con;
 	msim_con_res_t res;
-	errno_t rc;
+	int rc;
 
         ddf_msg(LVL_DEBUG, "msim_con_dev_add(%p)", dev);
@@ -122,5 +122,5 @@
 }
 
-static errno_t msim_con_dev_remove(ddf_dev_t *dev)
+static int msim_con_dev_remove(ddf_dev_t *dev)
 {
         msim_con_t *msim_con = (msim_con_t *)ddf_dev_data_get(dev);
@@ -131,5 +131,5 @@
 }
 
-static errno_t msim_con_dev_gone(ddf_dev_t *dev)
+static int msim_con_dev_gone(ddf_dev_t *dev)
 {
         msim_con_t *msim_con = (msim_con_t *)ddf_dev_data_get(dev);
@@ -140,5 +140,5 @@
 }
 
-static errno_t msim_con_fun_online(ddf_fun_t *fun)
+static int msim_con_fun_online(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "msim_con_fun_online()");
@@ -146,5 +146,5 @@
 }
 
-static errno_t msim_con_fun_offline(ddf_fun_t *fun)
+static int msim_con_fun_offline(ddf_fun_t *fun)
 {
         ddf_msg(LVL_DEBUG, "msim_con_fun_offline()");
